"""Test for compatibility with Mercurial API"""

import inspect
from nose.tools import *

from mercurial import ui as uimod

from tortoisehg.util import pipeui

def assert_same_argspec(f, g):
    fa, ga = inspect.getargspec(f), inspect.getargspec(g)
    assert_equals(fa, ga,
                  '%s != %s' % (inspect.formatargspec(*fa),
                                inspect.formatargspec(*ga)))

def overridden_methods(cls):
    basemethods = inspect.getmembers(cls.__base__, inspect.ismethod)
    return [(name, basemeth, getattr(cls, name))
            for name, basemeth in basemethods
            if basemeth.im_func is not getattr(cls, name).im_func]


def test_pipeui():
    ui = uimod.ui()
    pipeui.uisetup(ui)
    for name, basemeth, meth in overridden_methods(ui.__class__):
        yield assert_same_argspec, basemeth, meth
